local bump = require 'bump'
local gravity = 50
local velocity = 50
local player = {x=300,y=100,height=20,width=50,speedX=0,speedY=gravity,gravity=gravity,collision=0,length=0,rotation=0}
--player.colX = player.x-25
--player.colY = player.y-10
player.img = love.graphics.newImage("rocket_img.png")
local platform = {x=100,y=300,height=50,width=600}
local world = bump.newWorld()
world.windowWidth = love.graphics.getWidth()
world.windowHeight = love.graphics.getHeight()
player.burst = {}


function player.burst.add(x,y,img,dir)
  local burst = {}
  burst.x       = x
  burst.y       = y
  burst.height  = 5
  burst.width   = 5
  burst.dir     = dir
  burst.rnd     = math.random(-50,50)
  burst.speed   = 500
  burst.life    = 0
  burst.img     = img
  burst.scale   = 1
  world:add(burst, burst.x, burst.y, burst.width,burst.height)
  table.insert(player.burst,burst)
end

--function player.burst:draw(x,y,w,h)
  
--end

function love.load()
  
  world.rocketTileSet = love.graphics.newImage("rocket.png")
  world.rocket_1 = love.graphics.newQuad(0,0,5,5,world.rocketTileSet:getDimensions())
  world.rocket_2 = love.graphics.newQuad(5,0,5,5,world.rocketTileSet:getDimensions())
  world.rocket_3 = love.graphics.newQuad(10,0,5,5,world.rocketTileSet:getDimensions())
  world.rocket_4 = love.graphics.newQuad(15,0,5,5,world.rocketTileSet:getDimensions())
  world.rocket_5 = love.graphics.newQuad(20,0,5,5,world.rocketTileSet:getDimensions())

  world:add(player, player.x-25, player.y-10, player.width, player.height) -- x,y,w,h
  world:add(platform, platform.x, platform.y, platform.width,platform.height)
  
end

function love.update(dt)
    
  function love.keypressed(k)
    if k == "escape" then
      love.event.quit()
    end
  end
  
  if love.keyboard.isDown("left") then
    player.x = player.x + player.speedX*dt
    player.speedX = player.speedX - velocity*dt
  elseif love.keyboard.isDown("right") then
    player.x = player.x + player.speedX*dt
    player.speedX = player.speedX + velocity*dt
  else
    player.x = player.x + player.speedX*dt
    if player.speedX>0 then
      player.speedX = player.speedX - velocity*dt
      if player.speedX<1 and player.speedX>0 then
        player.speedX = 0
      end
    elseif player.speedX<0 then
      player.speedX = player.speedX + velocity*dt
    end
  end
  
    if love.keyboard.isDown("a") and love.keyboard.isDown("d") then
      player.y = player.y + player.speedY*dt
      player.speedY = player.speedY - 40*dt
      player.burst.add(player.x-21,player.y,world.rocket_1,"left")
      player.burst.add(player.x+17,player.y,world.rocket_1,"right")
    elseif love.keyboard.isDown("d") then
      player.y = player.y + player.speedY*dt
      player.speedY = player.speedY - 20*dt
      --player.rotation = player.rotation-1*dt 
      player.burst.add(player.x+17,player.y,world.rocket_1,"right")
    elseif love.keyboard.isDown("a") then
      player.y = player.y + player.speedY*dt
      player.speedY = player.speedY - 20*dt
      --player.rotation = player.rotation+1*dt
      player.burst.add(player.x-21,player.y,world.rocket_1,"left")
    else love.keyboard.isDown("down")
      player.y = player.y + player.speedY*dt
      player.speedY = player.speedY + 40*dt
      for i=1,player.length do
        if player.collision[i].normal.y == -1 then
          player.speedY = player.gravity
        end
      end
    end
  
  local sparkFilter = function(item, other)
    if other == platform   then return 'slide' end
  end
  
  for i,spark in ipairs(player.burst) do
    spark.y = spark.y + spark.speed*dt
    spark.x = spark.x + spark.rnd*dt
    spark.speed = spark.speed + 100*dt
    spark.life = spark.life+dt
    if spark.life < 0.05 and spark.life > 0.03 then
      spark.img = world.rocket_2
    elseif spark.life < 0.1 and spark.life >= 0.05 then
      spark.img = world.rocket_3
    elseif spark.life < 0.5 and spark.life >= 0.1 then
      spark.img = world.rocket_4
      spark.scale = 2
      world:update(spark, spark.x,spark.y,5*spark.scale,5*spark.scale)
    elseif spark.life >= 0.5 then
      spark.img = world.rocket_5
      spark.scale = 3
      world:update(spark, spark.x,spark.y,5*spark.scale,5*spark.scale)
    end
    local actualX, actualY, col, len = world:move(spark, spark.x, spark.y,sparkFilter)
    for x=1,len do
      if col[x].normal.y == -1 then
        spark.speed = -1*(0.15*spark.speed)
      end
      --table.remove(player.burst,i)
    end
    spark.x, spark.y = actualX, actualY
    if spark.y > 500 or spark.life>3 then
      table.remove(player.burst,i)
      world:remove(spark)
    end
  end
  
  --PLAYER COLLISION FUNCTION
  
  --player.colX = player.x-25
  --player.colY = player.y-10
  
  print(player.rotation)
  
  local playerFilter = function(item, other)
    if other == platform   then return 'slide' end
  end
  
  local actualX, actualY, col, len = world:move(player, player.x-player.width/2, player.y-player.height/2,playerFilter)
  player.collision = col
  player.length = len
  
  player.x, player.y = actualX+player.width/2, actualY+player.height/2
  
end

function love.draw()
  love.graphics.setBackgroundColor(102, 152, 255)
  --ROCKET ENGINES
  for i,spark in ipairs(player.burst) do
    if spark.dir == "left" then
      love.graphics.draw(world.rocketTileSet,spark.img,spark.x,spark.y,player.rotation,spark.scale,spark.scale)
    else 
      love.graphics.draw(world.rocketTileSet,spark.img,spark.x,spark.y,player.rotation,spark.scale,spark.scale)
    end
  end
  --PLAYER
  love.graphics.draw(player.img,player.x,player.y,player.rotation,1,1,player.width/2,player.height/2)
  --PLATTFORM
  love.graphics.rectangle("fill",platform.x,platform.y,platform.width,platform.height)
  
  
  --DEBUGGING STUFF
  for i=1,player.length do
    love.graphics.print(tostring(player.collision[i].normal.x.." // "..player.collision[i].normal.y), 20, 50+(i*10))
  end
  love.graphics.print("SpeedX: "..tostring(player.speedX), 20, 30)
  love.graphics.print("SpeedY: "..tostring(player.speedY), 20, 40)
  
end